package org.hidetake.elshard.demo.controller.demo.books;

import java.util.List;

import org.hidetake.elshard.demo.meta.BookMeta;
import org.hidetake.elshard.demo.model.Book;
import org.hidetake.elshard.demo.service.BookService;
import org.hidetake.jsonizer.Jsonizer;
import org.hidetake.jsonizer.PropertyGetter;
import org.slim3.controller.Controller;
import org.slim3.controller.Navigation;

public class AllController extends Controller
{

	private BookService bookService = new BookService();

	@Override
	protected Navigation run() throws Exception
	{
		List<Book> all = bookService.getAll();
		Jsonizer jsonizer = new Jsonizer();
		jsonizer.type(Book.class).with(new PropertyGetter<Book>()
		{
			private BookMeta m = BookMeta.get();
			@Override
			public void get(Book book)
			{
				property(book.getUser()).as(m.user);
				property(book.getCode()).as(m.code);
				property(book.getAuthor()).as(m.author);
				property(book.getTitle()).as(m.title);
			}
		});
		jsonizer.jsonize(all).send(response);
		return null;
	}

}
