package org.hidetake.elshard.demo.controller.test;

import java.util.logging.Logger;

import org.slim3.controller.Controller;
import org.slim3.controller.Navigation;

import com.google.appengine.api.taskqueue.Queue;
import com.google.appengine.api.taskqueue.QueueFactory;
import com.google.appengine.api.taskqueue.TaskOptions;
import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

public class UserInTaskTestController extends Controller
{
	
	private static final Logger logger = Logger.getLogger(UserInTaskTestController.class.getName());

	@Override
	protected Navigation run() throws Exception
	{
		if(request.getHeader("X-AppEngine-TaskName") == null) {
			return first();
		}
		else {
			return task();
		}
	}

	private Navigation first() throws Exception
	{
		Queue queue = QueueFactory.getDefaultQueue();
		TaskOptions task = TaskOptions.Builder
				.withMethod(TaskOptions.Method.POST)
				.url("/test/userInTaskTest");
		queue.add(task);
		return null;
	}

	private Navigation task() throws Exception
	{
		UserService userService = UserServiceFactory.getUserService();
		User user = userService.getCurrentUser();
		
		if(user != null) {
			logger.info("current user in task: "
					+user.getUserId()+", "
					+user.getNickname()+", "
					+user.getEmail()+", "
					+user.getFederatedIdentity()
					);
		}
		else {
			logger.info("current user is null");
		}
		
		return null;
	}

}
