package org.hidetake.elshard.demo.controller.tweet;

import java.util.ArrayList;
import java.util.List;

import org.hidetake.elshard.demo.meta.TweetTempMeta;
import org.hidetake.elshard.demo.model.Tweet;
import org.hidetake.elshard.demo.model.TweetTemp;
import org.hidetake.elshard.task.Context;
import org.hidetake.elshard.task.s3.QueryProcessorConfiguration;
import org.hidetake.elshard.task.s3.QueryProcessorController;
import org.slim3.datastore.Datastore;
import org.slim3.datastore.ModelQuery;
import org.slim3.util.BeanUtil;

public class CopyTempController extends QueryProcessorController<Tweet>
{

	@Override
	protected void configure(QueryProcessorConfiguration configuration)
	{
		configuration.setShardSize(500);
	}

	@Override
	public ModelQuery<Tweet> query(Context context)
	{
		return Datastore.query(Tweet.class);
	}

	@Override
	public void process(List<Tweet> input, Context context)
	{
		TweetTempMeta tempm = TweetTempMeta.get();
		List<TweetTemp> temps = new ArrayList<TweetTemp>(input.size());
		for(Tweet tweet : input) {
			TweetTemp tweetTemp = new TweetTemp();
			BeanUtil.copy(tweet, tweetTemp);
			tweetTemp.setKey(Datastore.createKey(tempm, tweet.getKey().getId()));
			
			temps.add(tweetTemp);
		}
		Datastore.put(temps);
	}

}
