package org.hidetake.elshard.demo.controller.tweet.delete;

import java.util.ArrayList;
import java.util.List;

import org.hidetake.elshard.demo.model.TweetTemp;
import org.hidetake.elshard.task.Context;
import org.hidetake.elshard.task.s3.QueryProcessorConfiguration;
import org.hidetake.elshard.task.s3.QueryProcessorController;
import org.slim3.datastore.Datastore;
import org.slim3.datastore.ModelQuery;

import com.google.appengine.api.datastore.Key;

public class DeleteTempController extends QueryProcessorController<TweetTemp>
{

	@Override
	protected void configure(QueryProcessorConfiguration configuration)
	{
		configuration.setShardSize(500);
	}

	@Override
	public ModelQuery<TweetTemp> query(Context context)
	{
		return Datastore.query(TweetTemp.class);
	}

	@Override
	public void process(List<TweetTemp> input, Context context)
	{
		List<Key> keys = new ArrayList<Key>(input.size());
		for(TweetTemp entity : input) {
			keys.add(entity.getKey());
		}
		Datastore.delete(keys);
	}

}
