package org.hidetake.elshard.demo.controller.tweet.parse;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.mapreduce.CounterGroup;
import org.hidetake.elshard.demo.mapper.tweet.ParseTweet;
import org.hidetake.elshard.demo.model.MapReduceState;
import org.hidetake.elshard.demo.service.MapReduceService;
import org.hidetake.elshard.demo.service.TweetParseJobnetService;
import org.hidetake.elshard.demo.service.TweetSurfaceService;
import org.slim3.controller.Controller;
import org.slim3.controller.Navigation;

/**
 * Mapperの完了後にカウンタを永続化する．
 * 
 * @author hidetake.org
 */
public class SaveCounterController extends Controller
{

	private final MapReduceService mapReduceService = new MapReduceService();
	private final TweetSurfaceService tweetSurfaceService = new TweetSurfaceService();
	private final TweetParseJobnetService tweetParseJobnetService = new TweetParseJobnetService();

	@Override
	public Navigation run() throws Exception
	{
		MapReduceState state = mapReduceService.getMapReduceState(param("job_id"));
		
		CounterGroup counterGroup = state.getCounters().getGroup(ParseTweet.COUNTER_GROUP_SURFACE);
		tweetSurfaceService.saveCounters(counterGroup);
		
		Configuration configuration = state.getConfigurationInstance();
		String userName = configuration.get(ParseTweet.CONFIG_USER_NAME);
		tweetParseJobnetService.release(userName);
		
		return null;
	}

}
