package org.hidetake.elshard.demo.controller.tweet.parse;

import org.hidetake.elshard.demo.service.TweetParseJobnetService;
import org.slim3.controller.Controller;
import org.slim3.controller.Navigation;
import org.slim3.controller.validator.Validators;

/**
 * Mapperを開始する．
 * 
 * @author hidetake.org
 */
public class StartParserController extends Controller
{

	private final TweetParseJobnetService tweetParseJobnetService = new TweetParseJobnetService();

	@Override
	public Navigation run() throws Exception
	{
		if(!validate()) {
			response.setContentType("text/plain");
			response.setCharacterEncoding("UTF-8");
			response.getWriter().append(errors.toString());
			response.setStatus(400);
			return null;
		}
		
		tweetParseJobnetService.startMapperJob(asString("userName"));
		return null;
	}

	private boolean validate()
	{
		Validators v = new Validators(request);
		v.add("userName", v.required());
		return v.validate();
	}

}
