package org.hidetake.elshard.demo.mapper;

import org.apache.hadoop.io.NullWritable;
import org.hidetake.elshard.demo.meta.TweetMeta;
import org.hidetake.elshard.demo.model.Tweet;

import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.tools.mapreduce.AppEngineMapper;

/**
 * すべてのエンティティをputする．
 * 100件単位でまとめて削除される．
 * 
 * @author hidetake.org
 */
public class BatchPut extends AppEngineMapper<Key, Entity, NullWritable, NullWritable>
{

	@Override
	public void map(Key key, Entity entity, Context context)
	{
		TweetMeta m = TweetMeta.get();
		Tweet tweet = m.entityToModel(entity);
		getAppEngineContext(context).getMutationPool().put(m.modelToEntity(tweet));
	}

}
