package org.hidetake.elshard.demo.mapper.tweet;

import org.apache.hadoop.io.NullWritable;
import org.hidetake.elshard.demo.meta.TweetMeta;
import org.hidetake.elshard.demo.meta.TweetTempMeta;
import org.hidetake.elshard.demo.model.Tweet;
import org.hidetake.elshard.demo.model.TweetTemp;
import org.slim3.datastore.Datastore;
import org.slim3.util.BeanUtil;

import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.tools.mapreduce.AppEngineMapper;

/**
 * ツイートをコピーする．
 *
 * @author hidetake.org
 */
public class CopyTweetToTemp extends AppEngineMapper<Key, Entity, NullWritable, NullWritable>
{

	@Override
	public void map(Key key, Entity entity, Context context)
	{
		TweetMeta m = TweetMeta.get();
		Tweet tweet = m.entityToModel(entity);
		
		TweetTempMeta tempm = TweetTempMeta.get();
		TweetTemp tweetTemp = new TweetTemp();
		BeanUtil.copy(tweet, tweetTemp);
		tweetTemp.setKey(Datastore.createKey(tempm, tweet.getKey().getId()));
		
		getAppEngineContext(context).getMutationPool().put(tempm.modelToEntity(tweetTemp));
	}

}
