package org.hidetake.elshard.demo.mapper.tweet;

import org.apache.hadoop.io.NullWritable;
import org.hidetake.elshard.demo.meta.TweetMeta;
import org.hidetake.elshard.demo.model.Tweet;

import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.tools.mapreduce.AppEngineMapper;

/**
 * ツイートをカウントする．
 *
 * @author hidetake.org
 */
public class CountTweet extends AppEngineMapper<Key, Entity, NullWritable, NullWritable>
{
	
	@Override
	public void map(Key key, Entity entity, Context context)
	{
		TweetMeta m = TweetMeta.get();
		Tweet tweet = m.entityToModel(entity);
		
		context.getCounter("UserName", tweet.getUserName()).increment(1);
		
		if(tweet.isFavorite()) {
			context.getCounter("Favorite", tweet.getUserName()).increment(1);
		}
	}

}
