package org.hidetake.elshard.demo.mapper.tweet;

import org.apache.hadoop.io.NullWritable;
import org.hidetake.elshard.demo.meta.TweetMeta;
import org.hidetake.elshard.demo.model.Tweet;

import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.tools.mapreduce.AppEngineMapper;

/**
 * ツイートを検索する．
 *
 * @author hidetake.org
 */
public class SearchTweetText extends AppEngineMapper<Key, Entity, NullWritable, NullWritable>
{

	private static final String CONFIG_KEYWORD = "org.hidetake.elshard.demo.mapper.tweet.SearchTweetText.keyword";

	@Override
	public void map(Key key, Entity entity, Context context)
	{
		TweetMeta m = TweetMeta.get();
		Tweet tweet = m.entityToModel(entity);
		
		String keyword = context.getConfiguration().get(CONFIG_KEYWORD);
		String status = tweet.getStatus();
		if(status.contains(keyword)) {
			context.getCounter("status", status).increment(1);
		}
	}

}
