package org.hidetake.elshard.demo.model;

import java.io.Serializable;
import java.util.Date;

import org.slim3.datastore.Attribute;
import org.slim3.datastore.Model;

import com.google.appengine.api.datastore.GeoPt;
import com.google.appengine.api.datastore.Key;

/**
 * Tweet model.
 * 
 * @author hidetake.org
 */
@Model
public class Tweet implements Serializable
{

	private static final long serialVersionUID = 1L;

	@Attribute(primaryKey = true)
	private Key key;

	private String userName;
	private Date date;
	private String status;
	private boolean retweet;
	private boolean favorite;
	private String replyTo;
	private GeoPt geometry;

	public Key getKey()
	{
		return key;
	}
	public void setKey(Key key)
	{
		this.key = key;
	}
	public String getUserName()
	{
		return userName;
	}
	public void setUserName(String userName)
	{
		this.userName = userName;
	}
	public Date getDate()
	{
		return date;
	}
	public void setDate(Date date)
	{
		this.date = date;
	}
	public String getStatus()
	{
		return status;
	}
	public void setStatus(String status)
	{
		this.status = status;
	}
	public boolean isRetweet()
	{
		return retweet;
	}
	public void setRetweet(boolean retweet)
	{
		this.retweet = retweet;
	}
	public String getReplyTo()
	{
		return replyTo;
	}
	public void setReplyTo(String replyTo)
	{
		this.replyTo = replyTo;
	}
	public GeoPt getGeometry()
	{
		return geometry;
	}
	public void setGeometry(GeoPt geometry)
	{
		this.geometry = geometry;
	}
	public boolean isFavorite()
	{
		return favorite;
	}
	public void setFavorite(boolean favorite)
	{
		this.favorite = favorite;
	}

}
