package org.hidetake.elshard.demo.service;

import java.util.ArrayList;
import java.util.List;

import org.apache.hadoop.mapreduce.Counter;
import org.apache.hadoop.mapreduce.CounterGroup;
import org.hidetake.elshard.demo.meta.TweetSurfaceMeta;
import org.hidetake.elshard.demo.model.TweetSurface;
import org.slim3.datastore.Datastore;

public class TweetSurfaceService
{

	/**
	 * 保存する．
	 * @param tweetSurfaces
	 */
	public void save(List<TweetSurface> tweetSurfaces)
	{
		Datastore.put(tweetSurfaces);
	}

	/**
	 * MapReduceカウンタを保存する．
	 * @param counterGroup
	 */
	public void saveCounters(CounterGroup counterGroup)
	{
		List<TweetSurface> list = new ArrayList<TweetSurface>();
		for(Counter counter : counterGroup) {
			String keyString = counter.getDisplayName();
			TweetSurface tweetSurface = TweetSurface.createFromKeyString(keyString);
			tweetSurface.setCount(counter.getValue());
			
			list.add(tweetSurface);
		}
		save(list);
	}

	/**
	 * 
	 * @param userName
	 * @return
	 */
	public List<TweetSurface> get(String userName, int limit)
	{
		TweetSurfaceMeta m = TweetSurfaceMeta.get();
		return Datastore.query(m)
				.filter(m.userNameAndCount.startsWith(userName))
				.sort(m.userNameAndCount.desc)
				.limit(limit)
				.asList();
	}

}
