package org.hidetake.elshard.task;

import java.util.List;

/**
 * The task which has input/output data.
 * 
 * @author hidetake.org
 */
public interface Task
{

	/**
	 * Process the task.
	 * @param input data passed from last task
	 * @param context the task context
	 * @return output data that will be passed to next task (return null if last)
	 */
	public abstract List<String> run(List<String> input, Context context) throws Exception;

}
