package org.hidetake.elshard.task.s3;

import org.hidetake.elshard.task.Configuration;
import org.hidetake.elshard.task.Input;
import org.hidetake.elshard.task.Task;
import org.hidetake.elshard.task.TaskChainRequestHandler;
import org.slim3.controller.Controller;
import org.slim3.controller.Navigation;

/**
 * Slim3 controller to handle request of the task chain.
 * 
 * @author hidetake.org
 */
public abstract class TaskChainController extends Controller implements Input, Task
{

	/**
	 * Configure the task chain.
	 * @return the configuration
	 */
	protected abstract void configure(Configuration configuration);

	@Override
	protected final Navigation run() throws Exception
	{
		TaskChainRequestHandler handler = new TaskChainRequestHandler(this, this);
		configure(handler.getConfiguration());
		handler.handle(request);
		return null;
	}

}
