package org.hidetake.elshard.task.splitter;

import java.util.ArrayList;
import java.util.List;

import org.hidetake.elshard.task.Splitter;

/**
 * Do-nothing splitter.
 * For example, <code>[a, b, c]</code> will be <code>[[a, b, c]]</code>
 * 
 * @author hidetake.org
 */
public class NoSplit implements Splitter
{

	@Override
	public List<List<String>> split(List<String> input)
	{
		if(input == null) {
			throw new NullPointerException("input is null");
		}
		List<List<String>> result = new ArrayList<List<String>>();
		result.add(input);
		return result;
	}

}
