package org.hidetake.elshard.util;

/**
 * 
 * The watch-dog timer.
 * 
 * @author hidetake.org
 */
public class Watchdog
{

	private long startMillis = 0L;
	private long timeoutMillis = Long.MAX_VALUE;

	/**
	 * Start the timer.
	 */
	public void start()
	{
		startMillis = System.currentTimeMillis();
	}

	/**
	 * Get elapsed time in millisecond.
	 * @return
	 */
	public long getElapsedTimeMillis()
	{
		return System.currentTimeMillis() - startMillis;
	}

	/**
	 * Has been timeout?
	 * @return
	 */
	public boolean isTimeout()
	{
		return getElapsedTimeMillis() > timeoutMillis;
	}

}
