package org.hidetake.elshard.demo.controller.test;

import org.slim3.tester.ControllerTestCase;
import org.hidetake.elshard.task.s3.TaskChainController;
import org.junit.Test;

import com.google.appengine.api.taskqueue.TaskQueuePb.TaskQueueAddRequest;

import static org.junit.Assert.*;

import static org.hamcrest.CoreMatchers.*;

public class TaskChainControllerTest extends ControllerTestCase
{

	@Test
	public void driver() throws Exception
	{
		tester.param("list",
				"one¥n" +
				"two¥n" +
				"three¥n" +
				"four¥n" +
				"five");
		tester.start("/test/taskChainTestCase");
		TaskChainController controller = tester.getController();
		assertThat(controller, is(notNullValue()));
		assertThat(tester.isRedirect(), is(false));
		assertThat(tester.getDestinationPath(), is(nullValue()));
		
		assertThat(tester.tasks.size(), is(1));
		TaskQueueAddRequest task = tester.tasks.get(0);
		assertThat(task.getUrl(), is(tester.request.getRequestURI()));
	}

}
