package org.hidetake.elshard.task.splitter;

import java.util.Arrays;
import java.util.List;

import org.hidetake.elshard.task.Splitter;
import org.junit.Test;

import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

public class SizeSplitterTest
{

	@Test(expected = IllegalArgumentException.class)
	public void badConstructorZero()
	{
		new SizeSplitter(0);
	}

	@Test(expected = IllegalArgumentException.class)
	public void badConstructorNegative()
	{
		new SizeSplitter(-1);
	}

	@Test
	public void split1_0() throws Exception
	{
		Splitter splitter = new SizeSplitter(1);
		List<String> input = Arrays.asList(
				// empty
				);
		@SuppressWarnings("unchecked")
		List<List<String>> expected = Arrays.asList(
				// empty
				);
		assertThat(splitter.split(input), is(expected));
	}

	@Test
	public void split1_1() throws Exception
	{
		Splitter splitter = new SizeSplitter(1);
		List<String> input = Arrays.asList(
				"a"
				);
		@SuppressWarnings("unchecked")
		List<List<String>> expected = Arrays.asList(
				Arrays.asList("a")
				);
		assertThat(splitter.split(input), is(expected));
	}

	@Test
	public void split1_3() throws Exception
	{
		Splitter splitter = new SizeSplitter(1);
		List<String> input = Arrays.asList(
				"a",
				"b",
				"c"
				);
		@SuppressWarnings("unchecked")
		List<List<String>> expected = Arrays.asList(
				Arrays.asList("a"),
				Arrays.asList("b"),
				Arrays.asList("c")
				);
		assertThat(splitter.split(input), is(expected));
	}

	@Test
	public void split2_3() throws Exception
	{
		Splitter splitter = new SizeSplitter(2);
		List<String> input = Arrays.asList(
				"a",
				"b",
				"c"
				);
		@SuppressWarnings("unchecked")
		List<List<String>> expected = Arrays.asList(
				Arrays.asList("a", "b"),
				Arrays.asList("c")
				);
		assertThat(splitter.split(input), is(expected));
	}

	@Test
	public void split3_3() throws Exception
	{
		Splitter splitter = new SizeSplitter(3);
		List<String> input = Arrays.asList(
				"a",
				"b",
				"c"
				);
		@SuppressWarnings("unchecked")
		List<List<String>> expected = Arrays.asList(
				Arrays.asList("a", "b", "c")
				);
		assertThat(splitter.split(input), is(expected));
	}

}
