/*
 * elshard demo global.js
 * (c) int128, 2010.
 */
var elshard = {};
elshard.pages = {
	'/': {
		title: 'Home',
		icons: {primary: 'ui-icon-home'},
		init: function(){
		}
	},
	'/demo/': {
		title: 'ElShard',
		icons: {primary: 'ui-icon-home'},
		booksTable: null,
		init: function(){
			var page = this;
			$('#tabs').tabs();
			$('#books-refresh').button({icons: {primary: 'ui-icon-refresh'}}).click(function(){
				page.refreshBooks();
			});
			page.booksTable = $('#books-table').dataTable({
				bJQueryUI: true,
				bAutoWidth: false,
				sPaginationType: "full_numbers",
				aaSorting: []
			});
			page.refreshBooks();
			$('#books-add button').button({icons: {primary: 'ui-icon-circle-plus'}});
			$('#books-add').submit(function(){
				$('#books-add').ajaxPost(function(){
					page.refreshBooks();
					$.jGrowl('Items added successfully.');
				});
				return false;
			});
			$('#books-delete button').button({icons: {primary: 'ui-icon-circle-minus'}});
			$('#books-delete').submit(function() {
				$('#books-delete button').attr('disabled', 'disabled');
				$('#books-delete').ajaxPost(function() {
					$('#books-delete button').removeAttr('disabled');
					$('#tabs').tabs('select', '#tab-datastore');
					$.jGrowl('Delete request queued successfully.');
				});
				return false;
			});
		},
		refreshBooks: function(){
			var page = this;
			page.booksTable.fnClearTable();
			$('#books_wrapper').ajaxGet('/demo/books/all', null, function(json){
				var rows = [];
				$.each(json, function(){
					rows.push([this.code, this.author, this.title, this.user]);
				});
				page.booksTable.fnAddData(rows);
			});
		}
	},
	'/tweet/parse/': {
		tweetResultTable: null,
		init: function(){
			var page = this;
			$('#tabs').tabs();
			$('#tweet-fetch button').button({icons: {primary: 'ui-icon-circle-plus'}});
			$('#tweet-fetch').submit(function(){
				$(this).ajaxPost(function(data){
					$.jGrowl('Fetch tweets in progress...');
				});
				return false;
			});
			page.tweetResultTable = $('#tweet-result-table').dataTable({
				bJQueryUI: true,
				bAutoWidth: false,
				sPaginationType: "full_numbers",
				aaSorting: []
			});
			$('#tweet-result button').button({icons: {primary: 'ui-icon-refresh'}});
			$('#tweet-result').submit(function(){
				page.tweetResultTable.fnClearTable();
				$(this).ajaxPost(function(data){
					var rows = [];
					$.each(data, function(){
						rows.push([this.surface, this.features, this.count]);
					});
					page.tweetResultTable.fnAddData(rows);
				});
				return false;
			});
		}
	}
};
// page framework by int128, 2010.
elshard.components = {
	navigation: {
		init: function(placeholder){
			$.each(elshard.pages, function(url){
				if(this.title == null){
					return;
				}
				this.button = $(document.createElement('input'))
					.attr('type', 'radio')
					.attr('id', this.title)
					.attr('name', 'navigation-radio')
					.attr('checked', (location.pathname == url) ? 'checked' : '')
					.click(function(){
						location.href = url;
					})
					.appendTo(placeholder);
				$(document.createElement('label'))
					.attr('for', this.title)
					.text(this.title)
					.appendTo(placeholder);
			});
			placeholder.buttonset();
			$.each(elshard.pages, function(){
				if(this.button){
					$(this.button).button({icons: this.icons});
				}
			});
		}
	}
};
elshard.util = {
	notifyGetError: function(xhr, text, error){
		$.jGrowl(xhr.responseText);
	},
	notifyPostError: function(xhr, text, error){
		$.jGrowl(xhr.responseText);
	}
};
$.fn.extend({
	ajaxPost: function(success, error){
		if(!$.isFunction(error)){
			error = elshard.util.notifyPostError;
		}
		$.ajax({
			context: this,
			type: 'POST',
			url: $(this).attr('action'),
			data: $(this).serialize(),
			beforeSend: function(){
				$(this).loading(true);
			},
			complete: function(xhr){
				$(this).loading(false);
			},
			success: success,
			error: error
		});
		return $(this);
	},
	ajaxGet: function(url, data, success, error){
		if(!$.isFunction(error)){
			error = elshard.util.notifyGetError;
		}
		if(data == null){
			data = {};
		}
		$.ajax({
			context: this,
			type: 'GET',
			url: url,
			data: data,
			beforeSend: function(){
				$(this).loading(true);
			},
			complete: function(xhr){
				$(this).loading(false);
			},
			error: error,
			success: success
		});
		return $(this);
	}
});
$(function(){
	// default props
	if($.loading){
		$.loading.img = '/css/loading1.gif';
		$.loading.align = 'center';
	}
	// common
	elshard.components.navigation.init($('#navigation'));
	// page
	var current = elshard.pages[location.pathname];
	if(current != null){
		if($.isFunction(current.init)){
			current.init();
		}
	}
});
