/*
 * Copyright (C) 2010 hidetake.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.hidetake.jsonizer;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Pattern;

import javax.servlet.http.HttpServletRequest;

public class JQueryPostDataReader
{

	private static final Pattern PATTERN_PARAM_INDEX = Pattern.compile("[\\[\\]]+");

	private final Map<String, Object> hash;

	private static boolean isArrayIndexString(String string)
	{
		for(char c : string.toCharArray()) {
			if(c < '0' || '9' < c) {
				return false;
			}
		}
		return true;
	}

	public JQueryPostDataReader()
	{
		hash = new HashMap<String, Object>();
	}

	public void read(HttpServletRequest request)
	{
		@SuppressWarnings("unchecked")
		Enumeration<String> keys = request.getParameterNames();
		
		while(keys.hasMoreElements()) {
			String key = keys.nextElement();
			String[] keyElements = PATTERN_PARAM_INDEX.split(key);
			String value = request.getParameter(key);
			
			Map<String, Object> currentMap = hash;
			for(String keyElement : keyElements) {
				Object child = currentMap.get(keyElement);
				if(isArrayIndexString(keyElement)) {
					if(child == null) {
						child = new ArrayList<Object>();
					}
				}
				else {
					
				}
			}
			
			System.out.println(Arrays.toString(keyElements)+": "+value);
		}
	}

}
